
////////////////////////////////////////////////////////////
//
//  uncomp.cpp
//

#include "map_compresser.h"

using namespace std;
using namespace RareCompresser;


UncompBuffer::UncompBuffer(ohstream &_ohs) : ohs(_ohs){
    
    count = 0;
    
}

UncompBuffer::~UncompBuffer(){
}


// 1bytef[^ǉ
void UncompBuffer::put(byte data){
    if (count == BUF_SIZE) flush();
    buf[count++] = data;
    return;
}

// o͐Xg[ɗ
void UncompBuffer::flush(){
    if (count == 0) return;
    if (count == 1){
        // 1XX : XX 𗘗pB(RXg3halfs, 1byte)
        ohs.puth(1);
        ohs.puth((buf[0] & 0xf0) >> 4); // XX(half)
        ohs.puth(buf[0] & 0x0f);        // XX(half)
    }else if (count == 2){
        // 2XXYY : XX YY 𗘗pB(RXg5halfs, 2bytes)
        ohs.puth(2);
        ohs.puth((buf[0] & 0xf0) >> 4); // XX(half)
        ohs.puth(buf[0] & 0x0f);        // XX(half)
        ohs.puth((buf[1] & 0xf0) >> 4); // YY(half)
        ohs.puth(buf[1] & 0x0f);        // YY(half)
    }else{
        // 0X... XoCg 𗘗pB(RXg[2X+2]halfs, Xbytes)
        ohs.puth(0);
        ohs.puth(count);        // X(TCYBobt@TCY0xFł邱Ƃɒ)
        for (int i=0; i<count; i++){
            ohs.puth((buf[i] & 0xf0) >> 4); // half
            ohs.puth(buf[i] & 0x0f);        // half
        }
    }
    count = 0;
    return;
}














