
////////////////////////////////////////////////////////////
//
//  map_converter.h
//

#ifndef _MAP_CONVERTER_
#define _MAP_CONVERTER_

////////////////////////////////////////////////////////////

// FMF wb_[
typedef struct _FMFHeader{

    char identifier[4];
    unsigned int size;
    unsigned int mapWidth;
    unsigned int mapHeight;
    unsigned char chipWidth;
    unsigned char chipHeight;
    unsigned char layerCount;
    unsigned char bitCount;

} FMFHeader;


// kwb_[
typedef struct _CMPHeader{
    
    unsigned char byte[4];
    unsigned short word[17];
    
} CMPHeader;

#define SIZE_OF_CMP_HEADER 0x26



typedef enum _ErrorNumber{
    ERROR_OVERFLOW,     // I[o[t[
    ERROR_ILG_POS,      // sȈʒu̎w
    ERROR_EOF           // \EOF̌o
} ErrorNumber;


// G[
typedef struct _ErrorInfo{
    
    ErrorNumber code;       // G[R[h
    unsigned int cbuf;      // G[ȍ݃TCY
    unsigned int type;      // kR[h̃^Cv((tO<<4) | (R[h0`F))
    unsigned int param;     // p[^(I[o[t[:TCY, sȈʒu:ʒu)
    
} ErrorInfo;
    

// n`O[v(t@C擾)
typedef struct _MapGroup{
    char name[256];          // O
    unsigned int offset;    // ItZbg(AhX)
    int vertical;           // ʂȂ0, cʂȂ1
    int height;             // (cʂ̏ꍇ)
}MapGroup;



////////////////////////////////////////////////////////////

#endif // _MAP_CONVERTER_




